diff --git a/src/backend/utils/activity/wait_event_timing.c b/src/backend/utils/activity/wait_event_timing.c
index 0fd5092b268..1cfdb112411 100644
--- a/src/backend/utils/activity/wait_event_timing.c
+++ b/src/backend/utils/activity/wait_event_timing.c
@@ -935,6 +1928,81 @@ pgstat_report_wait_end_timing(int capture_level)
 					(errmsg("some wait events will not be timed"),
 					 errdetail("A wait event was reported with a class unknown to the timing infrastructure.")));
 
+		/* Trace level: push the completed wait into the per-session ring. */
+		if (capture_level == WAIT_EVENT_CAPTURE_TRACE &&
+			!wait_event_trace_writes_disabled &&
+			!wait_event_trace_in_write)
+		{
+			/*
+			 * Lazy-attach the ring on first use here (not in the assign hook,
+			 * which must not ereport on OOM).  The writes-disabled gate also
+			 * blocks this re-attach during slot-state transitions
+			 * (release_slot / before_shmem_exit): without it a nested wait
+			 * event mid-transition could recurse into a fresh attach that
+			 * deadlocks on the lock the transition already holds.
+			 */
+			if (my_wait_event_trace == NULL && my_trace_proc_number >= 0)
+				wait_event_trace_attach(my_trace_proc_number);
+
+			if (my_wait_event_trace != NULL)
+			{
+				/*
+				 * Single-writer claim: a plain read+write avoids the LOCK
+				 * XADD that pg_atomic_fetch_add_u64 would emit on every wait
+				 * event.  Cross-backend readers use pg_atomic_read_u64 and
+				 * rely on the per-record seqlock below for safety.
+				 */
+				uint64		pos = pg_atomic_read_u64(&my_wait_event_trace->write_pos);
+				WaitEventTraceRecord *rec;
+				uint32		seq;
+
+				/*
+				 * Wait events emitted while a trace record is being written
+				 * must not themselves be ring-recorded (the gate above): the
+				 * record write is plain stores and cannot wait, but the
+				 * injection point below can, and the wait machinery it runs
+				 * (DSM registry lookup, condition-variable sleep) emits wait
+				 * events whose wait_end would recurse into this block --
+				 * re-running the injection point and self-deadlocking on
+				 * locks the outer invocation still holds.  Costs one
+				 * process-local store each way; nested waits still
+				 * accumulate in the stats above.
+				 */
+				wait_event_trace_in_write = true;
+
+				pg_atomic_write_u64(&my_wait_event_trace->write_pos, pos + 1);
+
+				/*
+				 * Injection point for the regression test of the
+				 * position-encoded identity seqlock: stalling here widens the
+				 * window between the write_pos store and the rec->seq store,
+				 * simulating weak-memory visibility that would otherwise be
+				 * unreachable on x86.  Compiled out unless
+				 * --enable-injection-points.
+				 */
+				INJECTION_POINT("wait-event-trace-after-write-pos", NULL);
+
+				rec = &my_wait_event_trace->records[pos & my_wait_event_trace->ring_mask];
+				seq = (uint32) (pos * 2 + 1);
+
+				rec->seq = seq;
+				pg_write_barrier(); /* payload stores must not rise above
+									 * seq=odd */
+
+				rec->record_type = TRACE_WAIT_EVENT;
+				rec->timestamp_ns = INSTR_TIME_GET_NANOSEC(now);
+				rec->data.wait.event = event;
+				rec->data.wait.pad2 = 0;
+				rec->data.wait.duration_ns = duration_ns;
+
+				pg_write_barrier(); /* payload stores must land before
+									 * seq=even */
+				rec->seq = seq + 1;
+
+				wait_event_trace_in_write = false;
+			}
+		}
+
 		INSTR_TIME_SET_ZERO(my_wait_event_timing->wait_start);
 	}
 }
@@ -1289,4 +2357,738 @@ pg_stat_reset_wait_event_timing_all(PG_FUNCTION_ARGS)
 	PG_RETURN_VOID();
 }
 
+/* ================= Trace-level readers ================= */
+
+/*
+ * SQL function: pg_get_backend_wait_event_trace()
+ *
+ * Returns trace records from the current backend's own ring buffer.  This
+ * function is deliberately session-local; cross-backend reading goes
+ * through pg_get_wait_event_trace(procnumber) below, which implements the
+ * snapshot-under-lock protocol documented on WaitEventTraceControl in
+ * wait_event_timing.h.  The name mirrors pg_get_backend_memory_contexts()
+ * to make the session-local scope explicit at the API level.
+ *
+ * Same-backend coordination with wait_event_trace_release_slot uses the
+ * wait_event_trace_srf_in_progress / _release_pending flags rather than
+ * an LWLock: same-backend serialization is implicit, so a per-backend
+ * bool plus a deferred-free path is sufficient and avoids any of the
+ * cross-backend lock-hold latency that the cross-backend reader pattern
+ * has to manage.  PG_TRY/PG_FINALLY guarantees the flag is cleared and
+ * any deferred dsa_free is performed even on ereport(ERROR).
+ *
+ * Uses InitMaterializedSRF (materialize-all).  The ring holds up to
+ * WaitEventTraceRingSize records (set at server start from the
+ * wait_event_trace_ring_size GUC; default 4 MB = 131072 records);
+ * full materialization caps the per-call cost at the ring size of
+ * tuplestore memory, which is acceptable for the use case this SRF
+ * is designed for: interactive own-session diagnostics from psql.
+ *
+ * This SRF is NOT the path for cross-backend monitoring tools: it is
+ * hard-coded to the calling backend's own ring, so a bgworker selecting
+ * from pg_backend_wait_event_trace via SPI would see only its own
+ * (typically empty) ring.  Cross-backend consumers use
+ * pg_get_wait_event_trace(procnumber) for SQL access, or implement the
+ * snapshot-under-lock protocol on WaitEventTraceControl directly.
+ *
+ * value-per-call (deferred) SRF mode would let an interactive
+ * "SELECT ... FROM pg_backend_wait_event_trace LIMIT N" short-circuit
+ * the materialisation, but converting this function would require
+ * spanning the wait_event_trace_srf_in_progress flag (and its
+ * deferred-free coordination with assign_wait_event_capture) across
+ * multiple SRF callbacks plus a transaction-cleanup registration to
+ * handle LIMIT abandonment.  The complexity is not
+ * justified for the diagnostic use case, especially since cross-
+ * backend monitoring (the consumer that would actually benefit from
+ * streaming) goes through the snapshot pattern above instead.
+ * Interactive callers who want only recent records should use
+ * "ORDER BY seq DESC LIMIT N" -- the LIMIT is applied after
+ * materialisation but the cost stays bounded by the ring size.
+ */
+Datum
+pg_get_backend_wait_event_trace(PG_FUNCTION_ARGS)
+{
+	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
+	WaitEventTraceState *ts;
+	uint64		write_pos;
+	uint64		read_start;
+	uint64		i;
+
+	InitMaterializedSRF(fcinfo, 0);
+
+	if (my_wait_event_trace == NULL)
+		PG_RETURN_VOID();
+
+	ts = my_wait_event_trace;
+
+	write_pos = pg_atomic_read_u64(&ts->write_pos);
+
+	if (write_pos == 0)
+		PG_RETURN_VOID();
+
+	/* Read from oldest available to newest */
+	{
+		uint64		ring_size = (uint64) ts->ring_mask + 1;
+
+		read_start = (write_pos > ring_size)
+			? write_pos - ring_size : 0;
+	}
+
+	/*
+	 * Mark the iteration in progress so wait_event_trace_release_slot defers
+	 * any concurrent dsa_free of our own ring (see the comment on that
+	 * function for the deferral protocol).  PG_FINALLY clears the flag and
+	 * performs any deferred free, even on ereport(ERROR).
+	 */
+	wait_event_trace_srf_in_progress = true;
+	PG_TRY();
+	{
+		for (i = read_start; i < write_pos; i++)
+		{
+			WaitEventTraceRecord *rec =
+				&ts->records[i & ts->ring_mask];
+			Datum		values[6];
+			bool		nulls[6];
+			const char *event_type;
+			const char *event_name;
+			uint32		seq_before;
+			uint32		seq_after;
+			uint8		rtype;
+			int64		timestamp_ns;
+			uint32		event_info;
+			int64		duration_ns;
+			int64		query_id;
+
+			/* Seqlock read */
+			seq_before = rec->seq;
+			pg_read_barrier();	/* acquire: payload loads below must not rise
+								 * above this */
+
+			if (seq_before & 1)
+				continue;
+
+			rtype = rec->record_type;
+			timestamp_ns = rec->timestamp_ns;
+
+			if (rtype == TRACE_WAIT_EVENT)
+			{
+				event_info = rec->data.wait.event;
+				duration_ns = rec->data.wait.duration_ns;
+				query_id = 0;
+			}
+			else if (rtype == TRACE_QUERY_START || rtype == TRACE_QUERY_END ||
+					 rtype == TRACE_EXEC_START || rtype == TRACE_EXEC_END)
+			{
+				event_info = 0;
+				duration_ns = 0;
+				query_id = rec->data.query.query_id;
+			}
+			else
+			{
+				pg_read_barrier();	/* acquire: pair with seq_before read
+									 * above before skipping */
+				continue;
+			}
+
+			pg_read_barrier();	/* acquire: payload loads must have landed
+								 * before seq_after */
+			seq_after = rec->seq;
+
+			if (seq_before != seq_after)
+				continue;
+
+			/* Skip empty wait events */
+			if (rtype == TRACE_WAIT_EVENT && event_info == 0)
+				continue;
+
+			if (rtype == TRACE_WAIT_EVENT)
+			{
+				event_type = pgstat_get_wait_event_type(event_info);
+				event_name = pgstat_get_wait_event(event_info);
+			}
+			else if (rtype == TRACE_QUERY_START)
+			{
+				event_type = "Query";
+				event_name = "QueryStart";
+			}
+			else if (rtype == TRACE_EXEC_START)
+			{
+				event_type = "Query";
+				event_name = "ExecStart";
+			}
+			else if (rtype == TRACE_EXEC_END)
+			{
+				event_type = "Query";
+				event_name = "ExecEnd";
+			}
+			else
+			{
+				event_type = "Query";
+				event_name = "QueryEnd";
+			}
+
+			if (event_type == NULL || event_name == NULL)
+				continue;
+
+			memset(nulls, 0, sizeof(nulls));
+
+			values[0] = Int64GetDatum((int64) i);
+			values[1] = Int64GetDatum(timestamp_ns);
+			values[2] = CStringGetTextDatum(event_type);
+			values[3] = CStringGetTextDatum(event_name);
+			values[4] = Float8GetDatum((double) duration_ns / 1000.0);
+			values[5] = Int64GetDatum(query_id);
+
+			tuplestore_putvalues(rsinfo->setResult,
+								 rsinfo->setDesc,
+								 values, nulls);
+		}
+	}
+	PG_FINALLY();
+	{
+		wait_event_trace_srf_in_progress = false;
+
+		/*
+		 * If a GUC step-down fired during iteration, it deferred the
+		 * dsa_free.  Process it now that we're safely past the loop. Re-check
+		 * release_pending under the same flag to handle the
+		 * (impossible-today, possible-tomorrow) case of a nested SRF.
+		 */
+		if (wait_event_trace_release_pending)
+		{
+			wait_event_trace_release_pending = false;
+			if (my_trace_proc_number >= 0)
+				wait_event_trace_release_slot(my_trace_proc_number);
+		}
+	}
+	PG_END_TRY();
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * One element of the local result buffer.  Pairs a per-record copy
+ * with the original ring index (used as the seq output column).
+ */
+typedef struct WetValidRecord
+{
+	uint64		ring_index;		/* original index in the writer's ring */
+	WaitEventTraceRecord rec;
+} WetValidRecord;
+
+/*
+ * Snapshot the trace ring for a given procNumber and emit records into
+ * the SRF's tuplestore.  Returns silently for FREE slots, out-of-range
+ * procnumbers, slots whose ring was never allocated, and slots whose
+ * write_pos is zero.
+ *
+ * Cross-backend reader protocol implemented here:
+ *
+ *   1. Read slot->state without the lock as a cheap "worth visiting"
+ *      check; FREE -> nothing to emit.
+ *   2. Allocate the worst-case result buffer BEFORE taking the lock,
+ *      so the palloc -- which can bottom out in a glibc mmap syscall
+ *      for the worst-case (full-ring) size -- runs without holding the
+ *      WaitEventTraceCtl lock.
+ *   3. Acquire WaitEventTraceCtl->lock in LW_SHARED.  All slot
+ *      transitions take LW_EXCLUSIVE, so the slot's identity, state,
+ *      and ring_ptr are stable for the duration of the iteration.
+ *   4. Re-check state under the lock and resolve ring_ptr via
+ *      dsa_get_address.  Read write_pos.
+ *   5. Iterate every live ring index [read_start, write_pos).  For
+ *      each record do the per-record POSITION-ENCODED IDENTITY
+ *      seqlock check ON SHARED MEMORY (see the comment on the loop
+ *      below).
+ *   6. Release the lock.
+ *   7. Walk the local result array and emit rows into the tuplestore.
+ *      This is the expensive part (potential disk spill); doing it
+ *      after release minimises lock-hold time.
+ *
+ * Why per-record seqlock against shared memory, not against a local
+ * memcpy of the full ring: the protocol requires the two seq reads
+ * to go to the SAME shared-memory location at DIFFERENT TIMES, with
+ * the payload read between them.  A bulk memcpy then seqlock-on-
+ * local-copy reads the same frozen byte twice, the check degenerates
+ * to a no-op, and torn / stale-cycle reads slip through.
+ *
+ * Why position-encoded identity, not just parity: the writer encodes
+ * the ring position into the seq value (mid-write = pos*2+1, complete
+ * = pos*2+2).  After RING_SIZE writes the slot wraps and is rewritten
+ * with a new numerically-distinct seq.  A parity-only check accepts
+ * any stable even seq -- including the PREVIOUS cycle's seq if cross-
+ * process visibility puts the new write_pos ahead of the new seq
+ * update.  See the loop body for the four failure modes the identity
+ * check rejects.
+ *
+ * Holding LW_SHARED throughout the iteration also makes the
+ * generation-counter retry unnecessary for this caller: slot
+ * transitions take LW_EXCLUSIVE and therefore cannot happen while we
+ * hold LW_SHARED.  The generation counter is still part of the
+ * cross-backend reader contract on WaitEventTraceControl for external
+ * readers that follow a different lock-release pattern (e.g. an
+ * extension that wants to release the lock between batches of records
+ * and re-acquire), but this in-tree implementation does not release
+ * the lock mid-iteration.
+ *
+ * Both OWNED and ORPHANED slots are read uniformly.  For OWNED the
+ * live owner is concurrently writing; the seqlock catches torn reads.
+ * For ORPHANED the records are immutable post-mortem so the check is
+ * essentially a pass-through (it still correctly skips at most one
+ * trailing odd-seq record if the owner died mid-write).
+ *
+ * Lock-hold is O(write_pos - read_start) shared-memory loads, at
+ * roughly the same wall-clock cost as a single 4 MB memcpy of the
+ * full ring (~1 ms on modern hardware), with no I/O and no syscalls.
+ */
+static void
+emit_wait_event_trace_for_procnumber(int procNumber, ReturnSetInfo *rsinfo)
+{
+	WaitEventTraceSlot *slot;
+	WaitEventTraceState *ts;
+	WetValidRecord *valid_records = NULL;
+	uint64		valid_count = 0;
+	uint64		write_pos;
+	uint64		read_start;
+	uint64		i;
+	uint32		state_now;
+
+	if (WaitEventTraceCtl == NULL)
+		return;
+
+	/*
+	 * Range check.  Negative or out-of-range procnumbers return an empty
+	 * result rather than ERRORing because the most natural use pattern for
+	 * cross-backend readers is to iterate every possible slot index (a
+	 * monitoring background worker doesn't know the exact
+	 * NUM_WAIT_EVENT_TIMING_SLOTS at SQL level), and silent- empty for
+	 * out-of-range matches the behaviour of sister functions like
+	 * pg_stat_get_wait_event_timing(NULL) which iterate the shared array
+	 * internally.  FREE-but-in-range slots also return empty (see the state
+	 * check below); the caller cannot distinguish out-of-range from FREE,
+	 * which is fine.
+	 */
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
+		return;
+
+	slot = &WaitEventTraceCtl->trace_slots[procNumber];
+
+	/*
+	 * If the trace DSA was never created (no backend in the cluster has ever
+	 * set wait_event_capture = trace), every slot is still in its initial
+	 * FREE state.  Skip without taking the lock.
+	 */
+	if (WaitEventTraceCtl->trace_dsa_handle == DSA_HANDLE_INVALID)
+		return;
+
+	/*
+	 * Unlocked fast-path check; the authoritative check is under the lock
+	 * below.
+	 */
+	if (pg_atomic_read_u32(&slot->state) == WAIT_EVENT_TRACE_SLOT_FREE)
+		return;
+
+	wait_event_trace_ensure_dsa();
+	if (trace_dsa == NULL)
+		return;
+
+	/*
+	 * Allocate the worst-case result buffer BEFORE taking the lock. The
+	 * buffer is sized for the full ring (sizeof(WetValidRecord) *
+	 * WaitEventTraceRingSize, e.g. ~5 MB at the 4 MB default ring and up to
+	 * ~42 MB at the 32 MB maximum); on a near-empty ring most goes unused,
+	 * but that is preferable to holding the WaitEventTraceCtl lock during a
+	 * palloc that may bottom out in a glibc mmap() syscall (allocations above
+	 * the malloc-mmap threshold).  Glibc's arena-internal mutex around the
+	 * syscall would serialise every concurrent reader of this lock through
+	 * one VMA-modifying kernel operation; sizing the alloc outside the lock
+	 * keeps the lock-hold time bounded by the per-record loop alone.
+	 *
+	 * After we acquire the lock we will either consume this buffer (writing
+	 * up to (write_pos - read_start) entries) or release it unused on an
+	 * early return.
+	 */
+
+	/*
+	 * Worst-case size = ring size.  Derive it from the GUC on first use in
+	 * this backend; subsequent calls see the cached value. The GUC is
+	 * PGC_POSTMASTER so the value is the same across every backend in this
+	 * postmaster run and never changes.
+	 */
+	if (WaitEventTraceRingSize == 0)
+		WaitEventTraceRingSize =
+			(uint32) wait_event_trace_ring_size * 1024U /
+			(uint32) sizeof(WaitEventTraceRecord);
+	valid_records = palloc(sizeof(WetValidRecord) * WaitEventTraceRingSize);
+
+	LWLockAcquire(&WaitEventTraceCtl->lock, LW_SHARED);
+
+	state_now = pg_atomic_read_u32(&slot->state);
+	if (state_now == WAIT_EVENT_TRACE_SLOT_FREE ||
+		!DsaPointerIsValid(slot->ring_ptr))
+	{
+		LWLockRelease(&WaitEventTraceCtl->lock);
+		pfree(valid_records);
+		return;
+	}
+
+	ts = (WaitEventTraceState *) dsa_get_address(trace_dsa, slot->ring_ptr);
+	write_pos = pg_atomic_read_u64(&ts->write_pos);
+
+	if (write_pos == 0)
+	{
+		LWLockRelease(&WaitEventTraceCtl->lock);
+		pfree(valid_records);
+		return;
+	}
+
+	/* Live range: oldest available to newest. */
+	{
+		uint64		ring_size = (uint64) ts->ring_mask + 1;
+
+		read_start = (write_pos > ring_size)
+			? write_pos - ring_size : 0;
+	}
+
+	for (i = read_start; i < write_pos; i++)
+	{
+		WaitEventTraceRecord *rec_shared =
+			&ts->records[i & ts->ring_mask];
+		WetValidRecord *out = &valid_records[valid_count];
+		uint32		expected_seq;
+		uint32		seq_before;
+		uint32		seq_after;
+
+		/*
+		 * Position-encoded seqlock identity check (NOT just parity).
+		 *
+		 * The writer encodes the ring position into the seq value: mid-write
+		 * -> (uint32)(pos * 2 + 1), complete -> + 2.  After RING_SIZE writes
+		 * the slot wraps and the same memory location gets a new seq value
+		 * (next_pos * 2 + 2) that is numerically distinct from the previous
+		 * cycle's seq.
+		 *
+		 * A parity-only check (skip on odd seq, accept on stable even) is
+		 * INSUFFICIENT for this layout in the cross-backend case: if the
+		 * writer just incremented write_pos to pos+1 but cross-process cache
+		 * coherence has not yet propagated the subsequent rec->seq =
+		 * (pos*2+1) store, this reader at i = pos would see the previous
+		 * cycle's complete-even seq (from logical position pos - RING_SIZE).
+		 * Both seq_before and seq_after would read that stale even value,
+		 * parity passes, identity-against-itself passes, and a record
+		 * belonging to the PREVIOUS cycle gets emitted with the new
+		 * ring_index = pos.  Silent data corruption (wrong attribution, not
+		 * torn bytes).
+		 *
+		 * The fix is identity against EXPECTED: a record is valid for
+		 * iterator position i if and only if its seq equals (uint32)(i * 2 +
+		 * 2) -- the writer's encoded "complete" value for that exact ring
+		 * position.  This rejects:
+		 *
+		 * * Stale prior cycle (seq <  expected): writer hasn't yet advanced
+		 * rec->seq for the current cycle. * Mid-write current cycle (seq ==
+		 * expected - 1, odd): writer is in the payload write window. * Ring
+		 * wrapped past us (seq >  expected): the writer completed a later
+		 * cycle on this slot during our read.
+		 *
+		 * The uint32 wraparound at 2^31 cycles is safe: we use exact
+		 * equality, and the writer's existing wrap-safety argument
+		 * (sizeof(seq) > worst-case in-flight window by 11 orders of
+		 * magnitude) covers the seq value.
+		 */
+		expected_seq = (uint32) (i * 2 + 2);
+
+		seq_before = rec_shared->seq;
+		pg_read_barrier();
+
+		if (seq_before != expected_seq)
+			continue;
+
+		out->rec = *rec_shared; /* one 32-byte structure copy */
+
+		pg_read_barrier();
+		seq_after = rec_shared->seq;
+
+		if (seq_after != expected_seq)
+			continue;
+
+		out->ring_index = i;
+		valid_count++;
+	}
+
+	LWLockRelease(&WaitEventTraceCtl->lock);
+
+	/*
+	 * Walk the local result array and emit rows.  No shared-memory access
+	 * from here on, so spills to disk by the tuplestore (if the result is
+	 * large) do not hold any wait-event-timing lock.
+	 */
+	for (i = 0; i < valid_count; i++)
+	{
+		WetValidRecord *vr = &valid_records[i];
+		WaitEventTraceRecord *rec = &vr->rec;
+		Datum		values[6];
+		bool		nulls[6];
+		const char *event_type;
+		const char *event_name;
+		uint8		rtype = rec->record_type;
+		uint32		event_info;
+		int64		duration_ns;
+		int64		query_id;
+
+		if (rtype == TRACE_WAIT_EVENT)
+		{
+			event_info = rec->data.wait.event;
+			duration_ns = rec->data.wait.duration_ns;
+			query_id = 0;
+
+			/* Skip empty wait events. */
+			if (event_info == 0)
+				continue;
+
+			event_type = pgstat_get_wait_event_type(event_info);
+			event_name = pgstat_get_wait_event(event_info);
+		}
+		else if (rtype == TRACE_QUERY_START)
+		{
+			event_info = 0;
+			duration_ns = 0;
+			query_id = rec->data.query.query_id;
+			event_type = "Query";
+			event_name = "QueryStart";
+		}
+		else if (rtype == TRACE_QUERY_END)
+		{
+			event_info = 0;
+			duration_ns = 0;
+			query_id = rec->data.query.query_id;
+			event_type = "Query";
+			event_name = "QueryEnd";
+		}
+		else if (rtype == TRACE_EXEC_START)
+		{
+			event_info = 0;
+			duration_ns = 0;
+			query_id = rec->data.query.query_id;
+			event_type = "Query";
+			event_name = "ExecStart";
+		}
+		else if (rtype == TRACE_EXEC_END)
+		{
+			event_info = 0;
+			duration_ns = 0;
+			query_id = rec->data.query.query_id;
+			event_type = "Query";
+			event_name = "ExecEnd";
+		}
+		else
+		{
+			/* Unrecognised record_type -- skip defensively. */
+			continue;
+		}
+
+		if (event_type == NULL || event_name == NULL)
+			continue;
+
+		memset(nulls, 0, sizeof(nulls));
+
+		values[0] = Int64GetDatum((int64) vr->ring_index);
+		values[1] = Int64GetDatum(rec->timestamp_ns);
+		values[2] = CStringGetTextDatum(event_type);
+		values[3] = CStringGetTextDatum(event_name);
+		values[4] = Float8GetDatum((double) duration_ns / 1000.0);
+		values[5] = Int64GetDatum(query_id);
+
+		tuplestore_putvalues(rsinfo->setResult,
+							 rsinfo->setDesc,
+							 values, nulls);
+	}
+
+	pfree(valid_records);
+}
+
+/*
+ * SQL function: pg_get_wait_event_trace(procnumber int4)
+ *
+ * Cross-backend trace ring reader.  Returns the records from the trace
+ * ring belonging to the backend that currently or previously occupied
+ * the given procNumber slot.  Reads OWNED and ORPHANED slots uniformly;
+ * FREE slots return an empty result.
+ *
+ * This SRF is the in-tree consumer of the orphan-preserved trace data:
+ * a backend that exited while wait_event_capture = trace leaves its
+ * ring allocated in DSA in ORPHANED state, and this function reads it
+ * until either a new backend takes over the same procNumber or the
+ * DBA calls pg_stat_clear_orphaned_wait_event_rings().  External
+ * extensions that need cross-backend access follow the same
+ * snapshot pattern documented on WaitEventTraceControl in
+ * wait_event_timing.h; this function serves as both the reference
+ * implementation and a DBA-facing diagnostic tool.
+ *
+ * Privileges: REVOKE'd from PUBLIC and GRANT'ed to pg_read_all_stats
+ * in system_views.sql, matching the privilege model of the session-
+ * local view pg_backend_wait_event_trace.
+ *
+ * The procnumber argument can be obtained from the procnumber column
+ * of pg_stat_get_wait_event_timing or pg_stat_get_wait_event_timing_
+ * overflow.  For pid-keyed access against live backends, callers can
+ * do:
+ *
+ *   SELECT * FROM pg_get_wait_event_trace(
+ *       (SELECT procnumber FROM pg_stat_get_wait_event_timing(<pid>)
+ *        WHERE pid = <pid> LIMIT 1));
+ *
+ * Note that pid-keyed access cannot read ORPHANED slots because a
+ * dying backend's pid is removed from procArray on exit; for
+ * post-mortem reading of short-lived backends (parallel workers,
+ * autovacuum, walsender) the procNumber must be captured before the
+ * backend exits, or discovered by iterating procnumbers in a
+ * monitoring background worker.
+ */
+Datum
+pg_get_wait_event_trace(PG_FUNCTION_ARGS)
+{
+	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
+	int32		procNumber = PG_GETARG_INT32(0);
+
+	InitMaterializedSRF(fcinfo, 0);
+
+	emit_wait_event_trace_for_procnumber((int) procNumber, rsinfo);
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * SQL function: pg_stat_clear_orphaned_wait_event_rings()
+ *
+ * Free every trace ring whose owner has exited (slot state ORPHANED).
+ * Returns the number of rings released.
+ *
+ * Why this exists.  When a backend that had wait_event_capture = trace
+ * exits, we deliberately do NOT free its ~4 MB trace ring (see the
+ * lifecycle discussion on WaitEventTraceControl): the data must remain
+ * readable by cross-backend consumers -- the in-tree
+ * pg_get_wait_event_trace SRF and any extension following the
+ * snapshot pattern on WaitEventTraceControl -- and an exit-time
+ * dsa_free would defeat that.
+ * The reclaim instead happens lazily in two places:
+ *
+ *   (a) wait_event_trace_clear_orphan_at_init(): when a new backend
+ *       inherits the same procNumber slot at init, it frees the prior
+ *       orphan as part of starting clean.  This handles the common
+ *       case (busy clusters with connection churn) automatically.
+ *
+ *   (b) THIS FUNCTION: an explicit DBA-driven sweep that releases
+ *       every currently orphaned ring at once.
+ *
+ * The pathological case (a) does not handle is "capture briefly
+ * enabled, then disabled, on a cluster with long-lived pooled
+ * connections that never exit".  In that scenario procNumbers do not
+ * recycle, so prior orphans persist until cluster restart unless the
+ * DBA calls this function.  Worst-case bound is
+ * NUM_WAIT_EVENT_TIMING_SLOTS * sizeof(WaitEventTraceState) which is
+ * ~400 MB at MaxBackends=100, ~4 GB at MaxBackends=1000 -- bounded
+ * but worth a kill switch.
+ *
+ * Permissions: execution is revoked from PUBLIC by default, matching the
+ * cluster-wide reset (pg_stat_reset_wait_event_timing_all).  This is a
+ * cluster-scope memory-reclamation operation: it can disrupt any
+ * concurrent cross-backend reader on any orphaned slot.  The
+ * disruption is bounded (readers retry via the generation counter
+ * and at worst skip one read) but the operation is still
+ * cluster-wide, so the default privilege matches the reset variant
+ * with the same blast radius; administrators can delegate with GRANT.
+ *
+ * The function is safe to call even when no orphans exist (returns
+ * 0) and even when capture is currently OFF (the slot array exists
+ * unconditionally; only the rings are lazy).
+ */
+Datum
+pg_stat_clear_orphaned_wait_event_rings(PG_FUNCTION_ARGS)
+{
+	int64		freed = 0;
+	int			i;
+
+	/*
+	 * Execution is revoked from PUBLIC in system_views.sql; administrators
+	 * can delegate with GRANT EXECUTE.
+	 */
+	if (WaitEventTraceCtl == NULL)
+		PG_RETURN_INT64(0);
+
+	/*
+	 * If no backend has ever enabled trace, the trace DSA was never created
+	 * and there cannot be any ORPHANED slots: every slot is still in its
+	 * initial FREE state.  Nothing to do.
+	 */
+	if (WaitEventTraceCtl->trace_dsa_handle == DSA_HANDLE_INVALID)
+		PG_RETURN_INT64(0);
+
+	/* Attach to the trace DSA so dsa_free() can be called. */
+	wait_event_trace_ensure_dsa();
+	if (trace_dsa == NULL)
+		PG_RETURN_INT64(0);
+
+	/*
+	 * Walk every slot, taking and releasing WaitEventTraceCtl->lock per slot
+	 * rather than holding it across the entire sweep.
+	 *
+	 * Rationale: at MaxBackends = 1000 with a fully-orphaned cluster the
+	 * per-slot work (atomic state read + dsa_free + ring_ptr clear + atomic
+	 * state write) totals a few microseconds; holding the lock across all
+	 * slots would yield a millisecond-scale lock-hold window during which
+	 * every concurrent backend startup (the lazy
+	 * wait_event_trace_clear_orphan_at_init path), every cross-backend reader
+	 * (pg_get_wait_event_trace and the external snapshot pattern), and every
+	 * capture step-down or restore would stall.  PG's general convention is
+	 * to keep LWLock-held windows in paths that compete with regular activity
+	 * well under 100 microseconds; per-slot release/reacquire gives us a
+	 * worst- case lock-hold of one slot's worth of work regardless of how
+	 * many orphans exist cluster-wide.
+	 *
+	 * An unlocked fast-path read of slot->state skips non-ORPHANED slots
+	 * without an LWLockAcquire/Release pair.  This is safe: if a slot races
+	 * from non-ORPHANED to ORPHANED after we read it, we miss that orphan --
+	 * but the function is documented as a snapshot sweep, the missed orphan
+	 * can be cleared by a subsequent call, and the same race exists for
+	 * orphans that appear after the loop ends.  The authoritative re-check
+	 * under the lock prevents racing on the dsa_free direction (we never free
+	 * a slot whose owner became OWNED again).
+	 *
+	 * CHECK_FOR_INTERRUPTS at the top of the loop body lets the caller cancel
+	 * a long sweep; with the previous single-lock structure the
+	 * InterruptHoldoffCount elevation from LWLockAcquire deferred all
+	 * cancellation until release.
+	 */
+	for (i = 0; i < NUM_WAIT_EVENT_TIMING_SLOTS; i++)
+	{
+		WaitEventTraceSlot *slot = &WaitEventTraceCtl->trace_slots[i];
+
+		CHECK_FOR_INTERRUPTS();
+
+		/* Unlocked fast-path: skip non-ORPHANED slots cheaply. */
+		if (pg_atomic_read_u32(&slot->state) != WAIT_EVENT_TRACE_SLOT_ORPHANED)
+			continue;
+
+		LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
+
+		/*
+		 * Authoritative re-check under the lock.  A concurrent
+		 * clear_orphan_at_init may have already freed this slot.
+		 */
+		if (pg_atomic_read_u32(&slot->state) == WAIT_EVENT_TRACE_SLOT_ORPHANED &&
+			DsaPointerIsValid(slot->ring_ptr))
+		{
+			pg_atomic_fetch_add_u64(&slot->generation, 1);
+			dsa_free(trace_dsa, slot->ring_ptr);
+			slot->ring_ptr = InvalidDsaPointer;
+			pg_atomic_write_u32(&slot->state, WAIT_EVENT_TRACE_SLOT_FREE);
+			freed++;
+		}
+
+		LWLockRelease(&WaitEventTraceCtl->lock);
+	}
+
+	PG_RETURN_INT64(freed);
+}
+
 #endif							/* USE_WAIT_EVENT_TIMING */
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 3d8c9bdebd5..b7e4caa9e3b 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -70,6 +70,7 @@
 #include "utils/snapmgr.h"
 #include "utils/syscache.h"
 #include "utils/timeout.h"
+#include "utils/wait_event_timing.h"
 
 /* has this backend called EmitConnectionWarnings()? */
 static bool ConnectionWarningsEmitted;
@@ -1250,6 +1251,16 @@ InitPostgres(const char *in_dbname, Oid dboid,
 	/* Process pg_db_role_setting options */
 	process_settings(MyDatabaseId, GetSessionUserId());
 
+#ifdef USE_WAIT_EVENT_TIMING
+
+	/*
+	 * Attach trace ring if wait_event_capture = trace was set via
+	 * config/db/role settings
+	 */
+	if (wait_event_capture == WAIT_EVENT_CAPTURE_TRACE && my_trace_proc_number >= 0)
+		wait_event_trace_attach(my_trace_proc_number);
+#endif
+
 	/* Apply PostAuthDelay as soon as we've read all options */
 	if (PostAuthDelay > 0)
 		pg_usleep(PostAuthDelay * 1000000L);
